"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const auth = __importStar(require("../auth"));
const server_1 = require("../__mocks__/server");
const msw_1 = require("msw");
const querystring_1 = __importDefault(require("querystring"));
test('getTokenWithPassword', () => __awaiter(void 0, void 0, void 0, function* () {
    const authSuccess = yield auth.authorizeWithUserPass(process.env.BASE_URL || '', process.env.TENANT || '', process.env.BASIC_AUTH || '', process.env.ADMIN_USER || '', process.env.ADMIN_PASS || '');
    expect(authSuccess).toBe(true);
}));
test('getTokenWithRefreshToken', () => __awaiter(void 0, void 0, void 0, function* () {
    const authSuccess = yield auth.authorizeWithRefreshToken(process.env.BASE_URL || '', process.env.TENANT || '', process.env.BASIC_AUTH || '', 'proper_refresh_token');
    expect(authSuccess).toBe(true);
}));
test('getTokenWithRefreshToken - wrong token', () => __awaiter(void 0, void 0, void 0, function* () {
    const authSuccess = yield auth.authorizeWithRefreshToken(process.env.BASE_URL || '', process.env.TENANT || '', process.env.BASIC_AUTH || '', 'proper_refresh_token1');
    expect(authSuccess).toBe(false);
}));
const authUrl = `${process.env.BASE_URL}/auth-oauth2/oauth/token`;
xtest('getAuthData test ', () => __awaiter(void 0, void 0, void 0, function* () {
    server_1.server.use(msw_1.rest.post(authUrl, (req, resp, ctx) => {
        const params = querystring_1.default.parse('' + req.body);
        const grantType = params['grant_type'];
        if (grantType === 'password') {
            const username = params['username'];
            if (params['username'] === 'anonymous') {
                return resp(ctx.status(200), ctx.json('GOOD_ANONYMOUS_TOKEN'));
            }
        }
        if (grantType === 'refresh_token') {
            const refreshToken = params['refresh_token'];
            if (refreshToken === 'TEST_REFRESH_TOKEN') {
                return resp(ctx.status(200), ctx.json('GOOD_TOKEN'));
            }
        }
        return resp(ctx.status(403));
    }));
    const refreshHandler = {
        getRefreshToken: () => 'TEST_REFRESH_TOKEN',
        setRefreshToken: () => { },
    };
    const ctx = {
        BASE_URL: process.env.BASE_URL || '',
        TENANT: process.env.TENANT || '',
        BASIC_AUTH: process.env.BASIC_AUTH || '',
        anonymousAuth: true,
    };
    const { token, UUID } = yield auth.authDataProvider(ctx, refreshHandler, false);
    expect(token).toBe(false);
}));
