import { IAuthDataProvider, IRefreshTokenHandler } from './orderTypes';
export interface ConnectWebSocketsParams {
    baseURL: string;
    tenant: string;
    venue: string;
    authDataProvider: IAuthDataProvider;
    refreshTokenHandler: IRefreshTokenHandler;
    onConnectedAsync: any;
    onDisconnectAsync: any;
    onKDSMessageAsync: any;
    onOrdersUpdateAsync: any;
    onNotificationAsync: any;
    onAuthFailure: any;
}
/**
 * Create Stomp on websocket connection to Ordering Stack listening for new orders to process by handlers/callback (onMessageAsync)
 *
 * @param {*} tenant
 * @param {*} venue
 * @param {*} accessTokenProviderCallbackAsync function called before connecting to STOMP server. Should return access token.
 * @param {*} onConnectedAsync async function (accessToken) {....}
 * @param {*} onDisconnectAsync
 * @param {*} onMessageAsync async function (message, accessToken) {....}
 */
export declare function connectWebSockets(params: ConnectWebSocketsParams): Promise<void>;
